/**
 * Simple Read
 * 
 * Read data from the serial port and change the color of a rectangle
 * when a switch connected to a Wiring or Arduino board is pressed and released.
 * This example works with the Wiring / Arduino program that follows below.
 */


import processing.serial.*;

Serial myPort;  // Create object from Serial class
int val;      // Data received from the serial port
int pos_x, pos_y;

void setup() 
{
  size(200, 200);
  // I know that the first port in the serial list on my mac
  // is always my  FTDI adaptor, so I open Serial.list()[0].
  // On Windows machines, this generally opens COM1.
  // Open whatever port is the one you're using.
  
  // List all the available serial ports
  println(Serial.list());

  String portName = Serial.list()[0];
  myPort = new Serial(this, portName, 9600);

  pos_x = 50;
  pos_y = 50;
}

void draw()
{
   // -----[ RÉCUPÉRATION DES ENTRÉES ET MODIFICATION DES VALEURS ]-----
   // get the ASCII string:
   String inString = myPort.readStringUntil('\n');

   if (inString != null)
   {
      // trim off any whitespace:
      inString = trim(inString);

      // compare string and do something
      if (inString.equals("UP"))
      {
         pos_y = (pos_y - 1) % 100;
      }
      else if (inString.equals("DOWN"))
      {
         pos_y = (pos_y + 1) % 100;
      }
      else if (inString.equals("LEFT"))
      {
         pos_x = (pos_x - 1) % 100;
      }
      else if (inString.equals("RIGHT"))
      {
         pos_x = (pos_x + 1) % 100;
      }
   }


   // -----[ AFFICHAGE ]-----
   background(255);             // Set background to white
   fill(200);

   rect(pos_x, pos_y, 100, 100);
}
